using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.IO.Ports;

namespace MotorFader
{
    public partial class Form1 : Form
    {
        Thread t;

        // access these with lock(this)
        int targetPosition = 512;
        int actualPosition = 512;
        bool isTouched = false;

        public Form1()
        {
            InitializeComponent();
            t = new Thread(read);
            //t.Priority = ThreadPriority.BelowNormal;
            t.Start();
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            t.Abort();

            base.OnClosing(e);
        }

        protected override void OnPaint(PaintEventArgs e)
        {
            lock (this)
            {
                progressBar1.Value = actualPosition;
                checkBox1.Checked = isTouched;
            }

            base.OnPaint(e);
        }

        private void read()
        {
            SerialPort sp = new SerialPort("COM4", 9600);
            sp.Open();
            try
            {
                sp.NewLine = "\r\n";
                sp.DiscardInBuffer();
                sp.DiscardOutBuffer();
                while (true)
                {
                    string s = sp.ReadLine();
                    string[] sSplit = s.Split(':');
                    if (sSplit.Length == 2)
                    {
                        System.Diagnostics.Trace.WriteLine("x" + s);
                        System.Diagnostics.Trace.WriteLine("y" + sSplit[0]);
                        System.Diagnostics.Trace.WriteLine("z" + sSplit[1]);
                        lock (this)
                        {
                            try
                            {
                                actualPosition = Int32.Parse(sSplit[0]);
                            }
                            catch (Exception)
                            { }
                            isTouched = !(sSplit[1].Equals("0"));

                            Invalidate();
                        }
                    }

                    if (sp.BytesToWrite == 0) // don't send too frequently
                    {
                        int pos = 512;
                        lock (this)
                        {
                            pos = targetPosition;
                        }
                        sp.Write("m" + pos.ToString() + ";");
                    }
                }
            }
            finally
            {
                sp.Close();
            }
        }

        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            lock (this)
            {
                targetPosition = trackBar1.Value;
            }
        }
    }
}